(*                        Parser  (c) Joachim Mohr
                          ======
   Ein mathematischer Parser berechnet aus einem Term z.B.
   '1/5*si_(30)+1/3*x^3' (Sinus im Gradma) den "Wert" des Strings 
   bei gegebenen x-Wert.
   [Im Programm ist erkennbar, welche Funktionen implementiert sind]
   (Eine Prfung auf syntaktische Korrektheit des Terms erfolgt nicht.) 
   Es wird hier an einer Wertetafel demonstriert.
   Die bernahme des Parsers in andere Programme ist leicht:
   Kopieren Sie die Funktionenzwischen AAA und BBB und rufen Sie
   in Ihrem Programm die Funktion "TermToReal" auf.

   Stichworte: Rekursive Funktion (Hier TermToReal)
               mathematischer Parser
               Format('%4.2f   %g', [x,y]));
  ------------------------------------------------------------------
  "Iterativ arbeiten ist menschlich, rekursiv arbeiten ist gttlich"
                                                            Anonym
   Rekursionen sind erstaunlich kurze, leicht verstndliche und
   effiziente Algorithmen.

   Ein groes Problem wird solange in Teilprobleme zerlegt, die hnlich
   strukturiert sind, bis das Problem einfach gelst werden kann.

   Hier z.B.: '2*8+5*9' wird zerlegt in
               '2*8' und '5*9' und dann in
               '2', '8', '5' und '9' als Strings.
               Mit StrToFloat werden diese in Zahlen umgeformt,
               dann wird rckwrts zweimal multipliziert und einmal addiert.
   Der Ursprung dieses Parser war und wurd dann immer mehr erweitert.
----------------------------------
function anfang(s:string;c:char):string;
begin
  anfang:=copy(s,1,pos(c,s)-1);
end;

function copyab(const s:string; const i:integer):string;
  begin result:=copy(s,i,length(s)-i+1) end;

function ende(s:string; c:char):string;
begin
  ende:=copyab(s,pos(c,s)+1)
end;


function TermToReal(s:string):real;
//  {Bisher nur '*' und '+' integriert}
begin
  if pos('+',s)>0  then result:=wert(anfang(s,'+'))+wert(ende(s,'+')) else
   if pos('*',s)>0 then  result:=wert(anfang(s,'*'))*wert(ende(s,'*')) else
    result:=StrToFloat(s);
end;
*)


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const kurs=1.95583;
var
  Form1: TForm1;

implementation

{$R *.DFM}
//------------- AAAAAAAAAAAAA ------------------------
//Allgemeine Funktionen
procedure showmessage0(s:string);
begin
   //hier sollte ihre Fehlerbehandlungsroutine stehen.
end;

function copyab(const s:string; const i:integer):string;  //Rest von s ab i. em Zeichen
  begin result:=copy(s,i,length(s)-i+1) end;

function ohneLeerzeichenf(const s:string):string;
   var n:integer;
 begin
   result:=s;
   repeat
     n:=pos(' ',result);
     if n>0 then result:=copy(result,1,n-1)+copyab(result,n+1)
   until n=0;
 end;

//----------- im Parser vorkommende Funktionen -----------------

function hoch(const x:real; n:integer):real; //x^n  n El Z
  begin
    if n<0 then result:=1/hoch(x,-n) else //x^n=1/x^(-n) fr n<0
      if n=0 then  result:=1 else
        result:=x*hoch(x,n-1)//rekursiv
  end;


function ArcTan2(Y, X: Extended): Extended;
asm
        FLD     Y
        FLD     X
        FPATAN
        FWAIT
end;

function ArcCos(X: Extended): Extended;
begin
  Result := ArcTan2(Sqrt(1 - X*X), X);
end;

function ArcSin(X: Extended): Extended;
begin
  Result := ArcTan2(X, Sqrt(1 - X*X))
end;


function asn(x:real):real; //arcsin
begin
  result:=0;
  if abs(x-1)<1E-15 then result:=pi/2 else     //asn(1)=Pi/2
    if abs(x+1)<1E-15 then result:=-Pi/2 else  //asn(-1)=-Pi/2
    if x*x<1 then result:=arcsin(x) //siehe unit tttmath
     else showmessage0('asn'+FloatToStr(x))
end;

function acs(x:real):real;   //Arccos
begin
 result:=0;
 if abs(x-1)<1E-15 then result:=0 else
   if abs(x+1)<1E-15 then result:=Pi else
     if x*x<1 then result:=arcCos(x) //siehe unit tttmath
     else showmessage0('asn'+floatToStr(x))
end;

function tan(x:real):real;
begin
 result:=0;
 if cos(x)<>0 then tan:=sin(x)/cos(x)
    else showmessage0('tan'+FloatToStr(x))
end;

function wurzel(x:real):real;
begin
  result:=0;
  if x>=-1E-15 //nicht negativ bis auf Rundungsfehler
    then wurzel:=sqrt(x)
      else showmessage0('sqr'+floatToStr(x))
end;



//----------------- Es folgt ein Parser ---------------------

FUNCTION TermToReal(s: string;x:real): real; //rekursiv!
                                  // s beliebiger Term ohne wissensch Not
                                  // d.h. 1E-17 nicht erlaubt
    var u,v,p,q: string;
    function e(c:char): boolean; //falls mglich wird s zerlegt in s=u+c+v
            //z.B. s=(5+4)*(3+2) Bei c='+' wird u=(5+4) und v=(3+2). Dann e=true
            //    Bei c='*' wird wegen der Klammern e=false
          var i,k:integer;
      begin k:=0; // k zhlt die Klammern
            i:=length(s)+1;
            repeat  dec(i);
              if s[i]=')' then inc(k);
              if s[i]='(' then k:=pred(k)
            until (i=1) or ((k=0) and (s[i]=c));
            if i=1 then Begin
              if k<>0 then
                showmessage0(s+'|'+floatToStr(k)+' Klammern zu viel!');
              result:=false
            End else Begin
              result:=true;
              u:=copy(s,1,i-1);
              v:=copyab(s,i+1)
            End
      end;
 begin
   result:=0;
   s:=OhneLeerzeichenf(s);
   u:=copy(s,1,3);
   v:=copyab(s,4);
   p:=copy(s,1,2);
   q:=copyab(s,3);
   if s='' then Begin result:=0; exit End;
   if s[1]='-' then s:='0'+s; //zB. s='-7/3x+14' -> s='0-7/3x+14'
 try {*****}
 {Punkt- vor Strichrechnung und vor Potenzen}
 if e('+') then result:=TermToReal(u,x)+TermToReal(v,x)        else
 if e('-') then result:=TermToReal(u,x)-TermToReal(v,x)        else
 if e('*') then result:=TermToReal(u,x)*TermToReal(v,x)        else
 if e('') then result:=TermToReal(u,x)*TermToReal(v,x)        else //''=#183
 if e('/') or e(':') then Begin
   try result:=TermToReal(u,x)/TermToReal(v,x);
   except showmessage0(u+'/'+v) end
 End else
  if e('^') then result:=hoch(TermToReal(u,x),round(TermToReal(v,x)))  else
  if p='lg' then Begin
    try result:=ln(TermToReal(q,x))/ln(10)
    Except showmessage0('Lg'+q) End;
  End else
  if p='ln' then Begin
    try result:=ln(TermToReal(q,x))
    except showmessage0('ln'+q) End
  End else
  if p='lb' then Begin
    try result:=ln(TermToReal(q,x))/ln(2);
    except showmessage0('lb'+q) End
  End else
  if u='sin' then result:=sin(TermToReal(v,x))             else //sin im Bogenma
  if u='cos' then result:=cos(TermToReal(v,x))             else
  if u='si_' then result:=sin(Pi/180*TermToReal(v,x))      else //sin im Gradma
  if u='atn' then Begin
    try result:=arctan(TermToReal(v,x));
    except showmessage0('atn'+v) End
  End else
  if u='asn' then result:=asn(TermToReal(v,x)) {Fehler s.o.} else
  if u='acs' then result:=acs(TermToReal(v,x)) {Fehler bei asn} else
  if u='at_' then Begin  //arTan im Gradma
    try result:=arctan(TermToReal(v,x))*180/Pi;
    except showmessage0('at_'+v) End
  End else
  if u='as_' then Begin //arcsin im Gradma
    try result:=asn(TermToReal(v,x))*180/Pi;
    except showmessage0('as_'+v) End
  End else
  if u='ac_' then Begin //arccos im Gradma
    try result:=acs(TermToReal(v,x))*180/Pi;
    except showmessage0('ac_'+v) End
  End      else
  if u='co_' then Begin  //arccos im Gradma
    try result:=cos(Pi/180*TermToReal(v,x));
    except showmessage0('co_'+v) End
  End      else
  if u='tan' then Begin
    try result:=tan(TermToReal(v,x));
    except showmessage0('tan'+v) End
  End             else
  if u='ta_' then Begin
    try result:=tan(Pi/180*TermToReal(v,x));
    except showmessage0('ta_'+v) End
  End else
  if u='abs' then result:=abs(TermToReal(v,x))             else
  if u='exp' then result:=exp(TermToReal(v,x))             else
  if u='wur' then result:=wurzel(TermToReal(v,x))          else //Dort Fehler
  if u='int' then result:=int(TermToReal(v,x))             else
  if u='rou' then result:=int(TermToReal(v,x)+0.5)         else
  if s[1]='(' then Begin
     while (length(s)>1) and (s[length(s)]<>')') do copy(s,1,length(s)-1);
    //z.B. 12*(250+50) DM
    s:=copy(s,2,length(s)-2);
    result:=TermToReal(s,x)
  End else if s='Pi' then result:=Pi else
    if s='x' then result:=x else //Variable x
    BEgin
      try result:=strToFloat(s); except showmessage0('Syntaxf. in '+s); result:=0; exit end;
    ENd
  except {******} showmessage0('Fehler in '+s) end;
 end;
//------------------------------ BBB ----------------------------------


procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then edit2.setfocus;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
    if key=#13 then edit3.setfocus;
end;

procedure TForm1.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
    if key=#13 then Button1Click(Nil); //TermToRealetafel
end;

procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then edit4.setfocus;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var x,xmax,step,y:real;
begin
  memo1.lines.clear;
  memo1.lines.add('  x       f(x)='+edit1.text);
  x:=TermToReal(edit2.text,0); //0 DummyTermToReal
  xmax:=TermToReal(edit3.text,0);
  step:=TermToReal(edit4.text,0);
  while x<=xmax+0.1 do Begin //nie "while x<>xmax do",
          //denn x=xmax wird nur mit Genauigkeit 1E-18 o.. erreicht
    y:=TermToReal(edit1.text,x);
    memo1.lines.add(Format('%4.2f   %g', [x,y]));
    x:=x+step;
  End;
end;

end.





